<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Automate cellulaire:  Fichier source de src/image.c</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Automate cellulaire
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Généré par Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Recherche');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Recherche');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">image.c</div>  </div>
</div><!--header-->
<div class="contents">
<a href="image_8c.html">Aller à la documentation de ce fichier.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;image.h&quot;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//                        Constructeur                        //</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="image_8c.html#af3ac482597fe1d1d8fdad40e3119b896">   25</a></span>&#160;<span class="comment"></span>FILE* <a class="code" href="image_8c.html#af3ac482597fe1d1d8fdad40e3119b896">creer_image</a>( ptr_str_fc f_config ){</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordtype">char</span>* <a class="code" href="structregle.html">regle</a> = (<span class="keywordtype">char</span>*)<a class="code" href="fichier__configuration_8c.html#ae0ce5e18cc06c038b2ae5ab594e5e9e7">get_regle</a>( f_config );</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keywordtype">char</span>* nom_fichier = (<span class="keywordtype">char</span>*)malloc( <span class="keyword">sizeof</span>(<span class="keywordtype">char</span>) * (strlen(<a class="code" href="structregle.html">regle</a>) + 15) );</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordflow">if</span>( nom_fichier == NULL ){</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        fprintf(stderr, <span class="stringliteral">&quot;Erreur d&#39;allocation de la place mémoire pour le nom du fichier image.\n&quot;</span>);</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        exit( EXIT_FAILURE );</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    }</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    strcpy( nom_fichier, DOSSIER_IMAGE);</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    strcat( nom_fichier, <span class="stringliteral">&quot;regle_&quot;</span>);</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    strcat( nom_fichier, <a class="code" href="structregle.html">regle</a>);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    strcat( nom_fichier, FORMAT_IMAGE);</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    FILE* fichier = <a class="code" href="fichier__configuration_8c.html#a0747aaffe60671eda2ba956722a8c191">get_enregistrer_image</a>(f_config) ? fopen( nom_fichier, <span class="stringliteral">&quot;wb&quot;</span> ) : fopen( nom_fichier, <span class="stringliteral">&quot;wt&quot;</span> );</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordflow">if</span>( fichier == NULL ){</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        fprintf(stderr, <span class="stringliteral">&quot;Erreur de création de fichier image.\n&quot;</span>);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        exit( EXIT_FAILURE );</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    }</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    free( nom_fichier );</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordflow">return</span> fichier;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;}</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="comment">//                       Autres Fonctions                     //</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="image_8c.html#a1251ec097153c17cdf6ef77b20e7eceb">   58</a></span>&#160;<span class="comment"></span><span class="keywordtype">void</span> <a class="code" href="image_8c.html#a1251ec097153c17cdf6ef77b20e7eceb">ecrire_entete_image</a>( FILE* fichier, ptr_str_fc f_config ){</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> NOMBRE_MAGIQUE = <a class="code" href="fichier__configuration_8c.html#af66f6107d4b7f6e4de23bd6f697ccaf8">get_nb_magique</a>(f_config);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="comment">// Si le fichier est en ASCII ou en binaire</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keywordflow">if</span>( (NOMBRE_MAGIQUE == 2) || (NOMBRE_MAGIQUE == 5) ){</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">char</span>* FORMAT = NOMBRE_MAGIQUE == 2 ? <span class="stringliteral">&quot;ASCII&quot;</span> : <span class="stringliteral">&quot;Binaire&quot;</span>;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        fprintf(fichier, <span class="stringliteral">&quot;P%d\n&quot;</span>, NOMBRE_MAGIQUE);</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        fprintf(fichier, <span class="stringliteral">&quot;# AUTOMATE CELLULAIRE: regle %s et format %s\n&quot;</span>, <a class="code" href="fichier__configuration_8c.html#ae0ce5e18cc06c038b2ae5ab594e5e9e7">get_regle</a>(f_config), FORMAT);</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        fprintf(fichier, <span class="stringliteral">&quot;%d %d\n&quot;</span>, <a class="code" href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a>(f_config), <a class="code" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a>(f_config));</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keywordflow">if</span>( NOMBRE_MAGIQUE == 2 ) fprintf(fichier, <span class="stringliteral">&quot;%d\n&quot;</span>, <a class="code" href="fichier__configuration_8c.html#afef69ee54144409041ea66d6e1185312">get_nb_etat</a>(f_config)-1);</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="keywordflow">else</span> fprintf(fichier, <span class="stringliteral">&quot;%d\n&quot;</span>, 255);</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    }</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        printf(<span class="stringliteral">&quot;Le nombre magique est incorrecte.\n&quot;</span>);</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        exit( EXIT_FAILURE );</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    }</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;}</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div>
<div class="line"><a name="l00084"></a><span class="lineno"><a class="line" href="image_8c.html#a9aac53703bab191011d8c1b8ec52b630">   84</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="image_8c.html#a9aac53703bab191011d8c1b8ec52b630">ecrire_donnees_image_ascii</a>( FILE* fichier, ptr_str_fc f_config, <span class="keywordtype">int</span>*** tableau){</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; <a class="code" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a>(f_config); i++){</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j &lt; <a class="code" href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a>(f_config); j++){</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            fprintf(fichier, <span class="stringliteral">&quot;%d  &quot;</span>, (*tableau)[i][j]);</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        }</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        fprintf(fichier, <span class="stringliteral">&quot;\n&quot;</span>);</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    }</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;}</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160; </div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div>
<div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="image_8c.html#a15ea0f80adae8f83b853c427a2254ae8">  101</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="image_8c.html#a15ea0f80adae8f83b853c427a2254ae8">ecrire_donnees_image_binaire</a>( FILE* fichier, ptr_str_fc f_config, <span class="keywordtype">int</span>*** tableau){</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; <a class="code" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a>(f_config); i++){</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j &lt; <a class="code" href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a>(f_config); j++){</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;            (*tableau)[i][j] = ((*tableau)[i][j] * 255) / (<a class="code" href="fichier__configuration_8c.html#afef69ee54144409041ea66d6e1185312">get_nb_etat</a>(f_config) - 1);</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            fwrite(&amp;((*tableau)[i][j]), <span class="keyword">sizeof</span>(<span class="keywordtype">char</span>), 1, fichier);</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        }</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    }</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;}</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160; </div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="afichier__configuration_8c_html_a0747aaffe60671eda2ba956722a8c191"><div class="ttname"><a href="fichier__configuration_8c.html#a0747aaffe60671eda2ba956722a8c191">get_enregistrer_image</a></div><div class="ttdeci">bool get_enregistrer_image(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;enregistrer_image&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00156">fichier_configuration.c:156</a></div></div>
<div class="ttc" id="aimage_8c_html_a15ea0f80adae8f83b853c427a2254ae8"><div class="ttname"><a href="image_8c.html#a15ea0f80adae8f83b853c427a2254ae8">ecrire_donnees_image_binaire</a></div><div class="ttdeci">void ecrire_donnees_image_binaire(FILE *fichier, ptr_str_fc f_config, int ***tableau)</div><div class="ttdoc">Ecrit les données d'une image PGM dans un format binaire (nombre magique P5)</div><div class="ttdef"><b>Definition:</b> <a href="image_8c_source.html#l00101">image.c:101</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_afc113bc5216673e023757de45be2e009"><div class="ttname"><a href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a></div><div class="ttdeci">unsigned int get_hauteur(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;hauteur&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00111">fichier_configuration.c:111</a></div></div>
<div class="ttc" id="aimage_8c_html_a9aac53703bab191011d8c1b8ec52b630"><div class="ttname"><a href="image_8c.html#a9aac53703bab191011d8c1b8ec52b630">ecrire_donnees_image_ascii</a></div><div class="ttdeci">void ecrire_donnees_image_ascii(FILE *fichier, ptr_str_fc f_config, int ***tableau)</div><div class="ttdoc">Ecrit les données d'une image PGM dans un format ASCII (nombre magique P2).</div><div class="ttdef"><b>Definition:</b> <a href="image_8c_source.html#l00084">image.c:84</a></div></div>
<div class="ttc" id="aimage_8c_html_a1251ec097153c17cdf6ef77b20e7eceb"><div class="ttname"><a href="image_8c.html#a1251ec097153c17cdf6ef77b20e7eceb">ecrire_entete_image</a></div><div class="ttdeci">void ecrire_entete_image(FILE *fichier, ptr_str_fc f_config)</div><div class="ttdoc">Ecrit dans l'en-tête de l'image passé en paramètres les éléments définit au préalable dans le fichier...</div><div class="ttdef"><b>Definition:</b> <a href="image_8c_source.html#l00058">image.c:58</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_a1b660f6a0cca911778798dfe26976cdd"><div class="ttname"><a href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a></div><div class="ttdeci">unsigned int get_largeur(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;largeur&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00122">fichier_configuration.c:122</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_afef69ee54144409041ea66d6e1185312"><div class="ttname"><a href="fichier__configuration_8c.html#afef69ee54144409041ea66d6e1185312">get_nb_etat</a></div><div class="ttdeci">unsigned int get_nb_etat(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;nb_etat&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00100">fichier_configuration.c:100</a></div></div>
<div class="ttc" id="astructregle_html"><div class="ttname"><a href="structregle.html">regle</a></div><div class="ttdoc">Une regle.</div><div class="ttdef"><b>Definition:</b> <a href="regle_8c_source.html#l00031">regle.c:31</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_af66f6107d4b7f6e4de23bd6f697ccaf8"><div class="ttname"><a href="fichier__configuration_8c.html#af66f6107d4b7f6e4de23bd6f697ccaf8">get_nb_magique</a></div><div class="ttdeci">unsigned int get_nb_magique(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;nb_magique&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00167">fichier_configuration.c:167</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_ae0ce5e18cc06c038b2ae5ab594e5e9e7"><div class="ttname"><a href="fichier__configuration_8c.html#ae0ce5e18cc06c038b2ae5ab594e5e9e7">get_regle</a></div><div class="ttdeci">char * get_regle(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;regle&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00089">fichier_configuration.c:89</a></div></div>
<div class="ttc" id="aimage_8c_html_af3ac482597fe1d1d8fdad40e3119b896"><div class="ttname"><a href="image_8c.html#af3ac482597fe1d1d8fdad40e3119b896">creer_image</a></div><div class="ttdeci">FILE * creer_image(ptr_str_fc f_config)</div><div class="ttdoc">Crée un fichier image au format (.pgm) ainsi qu'un pointeur de fichier.</div><div class="ttdef"><b>Definition:</b> <a href="image_8c_source.html#l00025">image.c:25</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Généré par &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
